function ger45000_Prospect_Controller(
  ScreenService,
  Utilities,
  Operador_Repository,
  ValidationEngine,
  templateManager,
  General,
  restEngine,
  Endereco,
  ger00004500_Prospect_Service,
  ZHPromise,
  CRM_Utilities,
  Messages,
  ABEvolucaoController,
  crm00002001_OportunidadeNegocio_Controller,
  AbaInterlocutorController,
  ABAEnderecoParceiroController,
  PartnerInfosModalController,
  evolutionTabController,
  ABALogotipoParceiroController,
  ZhFilterPreferences,
  CRM_ParceiroNegocio_Controller,
  CRM_ParceiroNegocio_Service
) {
  CRM_Utilities.addController(this, "ger45000_Prospect_Controller");

  var self = this;
  var opportunityWidgetActions;

  this.setAuditInfo = function (widget) {
    var currentRow = widget.currentRow;

    if (widget.currentRow.__is_new) {
      currentRow.DTINCLUSAO = self.momentNow();
      currentRow.CDOPERINCLUSAO = currentRow.CODOPERLOGGED;
      currentRow.CDOPERULTATU = currentRow.CODOPERLOGGED;
      currentRow.NRORGULTATU = currentRow.NRORG;
    } else {
      currentRow.DTULTATU = self.momentNow();
      currentRow.CDOPERULTATU = currentRow.CODOPERLOGGED;
      currentRow.NMOPERULTATU = currentRow.NMOPERLOGGED;
      currentRow.NRORGULTATU = currentRow.NRORG;
    }
  };

  this.gridProspectAfterMoveRow = function (widget) {
    var IntegracaoRDStationController = CRM_Utilities.getController(
      "IntegracaoRDStationController"
    );

    this.shootsMainWidgetEventsAfterMoveRow(widget);
    IntegracaoRDStationController.insertSendActionRD(widget, "Prospect");
    CRM_ParceiroNegocio_Controller.setInscEstadualSelect(widget);

    if (!widget.currentRow.__is_new) {
      this.setUnmergeActionVisibility(widget);
    }
  };

  this.setOperatorLoggedInCurrentRow = function () {
    var user = {
      cdoperador: getLocalVar("CRM_CDOPERADOR"),
      nrorg: getLocalVar("CRM_NRORG"),
    };

    Operador_Repository.retornaOperadorLogado(user).then(function (operator) {
      if (self.operatorIsValid(operator) === false) {
        return;
      }
      var widget = templateManager.container.getActiveWidget();

      widget.currentRow.CODOPERLOGGED = operator[0].CDOPERADOR;
      widget.currentRow.NMOPERLOGGED = operator[0].NMOPERADOR;
    });
  };

  this.getFilterPosition = function (dataSourceFilter, name) {
    var indexFilterObject;

    dataSourceFilter.forEach(function (value, i) {
      if (value.name === name) {
        indexFilterObject = i;
        return;
      }
    });
    return indexFilterObject;
  };

  this.operatorIsValid = function (operator) {
    if (operator[0] === undefined || operator[0] === null) {
      ScreenService.showMessage("Erro ao realizar a operação.");
      return false;
    }
    return true;
  };

  this.momentNow = function () {
    return moment(new Date()).format("DD/MM/YYYY HH:mm:ss");
  };

  this.createEqualFilter = function (name, value) {
    var filter = [
      {
        name: name,
        operator: "=",
        value: value,
      },
    ];
    return filter;
  };

  this.validationPhone = function (field) {
    var numberSizeReceived = field.value().replace(/[^0-9]/g, "").length;
    if (
      numberSizeReceived !== 10 &&
      numberSizeReceived !== 11 &&
      numberSizeReceived !== 12
    ) {
      ScreenService.showMessage("Telefone Inválido");
      field.clearValue();
      return false;
    }
  };

  this.setAddressDefaultValue = function (currentRow) {
    currentRow.CDPAIS = "";
    currentRow.SGESTADO = "";
    currentRow.CDMUNICIPIO = "";
    currentRow.CDBAIRRO = "";
  };

  this.setWidgetsVisibility = function (widgetParent, value) {
    widgetParent.widgets.forEach(function (widget) {
      widget.isVisible = value;
    });
  };

  this.verificaEndereco = function (widget) {
    var fields = widget.fields;
    widget.currentRow.REPLICAENDERECO = false;
    widget.currentRow.CODOPERLOGGED = widget.getParent().currentRow.CODOPERLOGGED;
    fields.forEach(function (field) {
      if (field.fieldGroup == "ENDER_INTER") {
        if (!Util.isEmptyOrBlank(field.value()))
          widget.currentRow.REPLICAENDERECO = true;
        else field.setValue("");
      }
    });
  };

  this.saveProspectAndSetAudit = function () {
    var widget = templateManager.container.getActiveWidget();
    if (widget.isValid()) {
      if (Util.isEmptyOrBlank(widget.currentRow.NMFANTPROS)) {
        widget.currentRow.NMFANTPROS = widget.currentRow.NMRAZSOCPROS;
      }
      widget.currentRow.NRINSJURPROS = widget.currentRow.NRINSJURPROS.toString().replace(
        /[^0-9]/g,
        ""
      );
      widget.currentRow.CDTIPOPARCEIRO = "PROSPECT";
      widget.currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
      this.setAuditInfo(widget);

      CRM_Utilities.saveWidget(widget, false).then(
        function (response) {
          if (widget.currentRow.__is_new) {
            widget.currentRow.NRPARCNEGOCIO =
              response.dataset.DADOS.NRPARCNEGOCIO;
          }
          this.classConcorrente(widget);
          this.saveEnderecoProspect(widget)
            .then(function () {
              if (response && response.dataset && response.dataset.DADOS) {
                widget.reload().then(function () {
                  widget.view();
                });
              } else {
                widget.reload();
              }
            })
            .catch(function (error) {
              CRM_Utilities.showErrorMessage(error);
              widget.reload();
            });

          widget.currentRow.DIASFIMCONTRATO = this.calculaDiasFimContrato(
            widget.currentRow.DTFIMVIGENCIA
          );

          widget.currentRow.NRCONCORRPROSPECT = response.dataset.CONCORRENTE
            ? response.dataset.CONCORRENTE.NRCONCORRPROSPECT
            : widget.currentRow.NRCONCORRPROSPECT;
        }.bind(this)
      );
    }
  };

  this.saveEnderecoProspect = function (widget) {
    // Promise que será resolvida quando o endereço for salvo
    var deferred = ZHPromise.defer();

    var parametroRestEngine = {
      requestType: "Row",
      row: {
        NRPARCNEGOCIO: widget.currentRow.NRPARCNEGOCIO,
        NRORG: widget.currentRow.NRORG,
      },
    };

    restEngine.post(
      "/crm_enderecoparc/findEndereco",
      parametroRestEngine,
      function (response) {
        var row = {
          NRPARCNEGOCIO: widget.currentRow.NRPARCNEGOCIO,
          CDTIPOENDERECO: "PRINCIPAL",
          NRORG: widget.currentRow.NRORG,
          IDATIVO: "S",
          CDPAIS: widget.currentRow.CDPAIS,
          SGESTADO: widget.currentRow.SGESTADO,
          CDMUNICIPIO: widget.currentRow.CDMUNICIPIO,
          CDBAIRRO: widget.currentRow.CDBAIRRO,
          CDLOGRADOURO: widget.currentRow.CDLOGRADOURO,
          NMBAIRROENDERECO: widget.currentRow.NMBAIRROENDERECO,
          DSCOMPLEENDERECO: widget.currentRow.DSCOMPLEENDERECO,
          NRCEPENDERECO: widget.currentRow.NRCEPENDERECO,
          DSENDERECO: widget.currentRow.DSENDERECO,
          NRIMOVELENDERECO: widget.currentRow.NRIMOVELENDERECO,
        };

        if (response.dataset.columnsToReturn[0]) {
          row.__is_new = false;
          row.tipoEnderecoWasEdited = false;
        } else row.__is_new = true;

        CRM_ParceiroNegocio_Service.salvarEndereco(row)
          .then(
            function (successData) {
              if (widget.isNewRow()) {
                if (successData.dataset) {
                  widget.currentRow.NRENDERECOPARC =
                    successData.dataset.columnsToReturn.NRENDERECOPARC;
                }
                widget.currentRow.__is_new = false;
              }
              deferred.resolve();
            },
            function (error) {
              var errorMessage = "Timeout";
              if (error.data) {
                errorMessage = error.data.error;
              }
              ScreenService.showMessage(errorMessage);
            }
          )
          .catch(CRM_Utilities.showErrorMessage);
      },
      undefined,
      function (error) {
        CRM_Utilities.showErrorMessage(error);
      },
      null,
      3000000
    );

    return deferred;
  };

  //Função usada tanto na tela de lead quanto na de prospect!
  this.mergeProspect = function (widget) {
    var mainWid = widget.getParent();

    if (widget.isValid()) {
      var parametroRestEngine = {
        requestType: "Row",
        row: widget.currentRow,
      };

      CRM_Utilities.post(
        "/mergeParceiro",
        parametroRestEngine,
        undefined,
        undefined,
        undefined
      ).then(
        function (response) {
          CRM_Utilities.reloadGridInViewMode(mainWid).then(() => {
            this.setUnmergeActionVisibility(mainWid);
            widget.currentRow.NRPARCORIGEM = "";
            widget.currentRow.NRPARCORIGEM = "";
            this.closeWidgetFundirParc(widget);
            ScreenService.showMessage("Processo realizado com sucesso!");
          });
        }.bind(this)
      );
    }
  };

  this.openSwipeFundirAndSetName = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var widgetFundir = templateManager.container.getWidget(
                  "FUNDIRPROSP"
                );
                var fieldOrigem = widgetFundir.getField("NRPARCORIGEM");

                ScreenService.closePopup();
                ScreenService.openPopup(widgetFundir);

                widgetFundir.activate();
                widgetFundir.newRow();

                widgetFundir.currentRow.NMDESTINO =
                  widget.currentRow.NMRAZSOCPROS;
                widgetFundir.currentRow.NRPARCDESTINO =
                  widget.currentRow.NRPARCNEGOCIO;
                widgetFundir.currentRow.NRORG = widget.currentRow.NRORG;
                widgetFundir.currentRow.CDOPEREVOL =
                  templateManager.LOGGEDOPERATOR.CDOPERADOR;

                var origemFilter = CRM_Utilities.getComponentDataSourceFilter(
                  fieldOrigem,
                  "NRPARCORIGEM"
                );

                origemFilter.value = widget.currentRow.NRPARCNEGOCIO;
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.closeWidgetFundirParc = function (widget) {
    ScreenService.closePopup();
    self.cleanWidgetFields(widget);
    widget.getParent().view();
    widget.getParent().activate();
  };

  this.cleanWidgetFields = function (widget) {
    widget.fields.forEach(function (field) {
      field.value("");
    });
  };

  /**
   * Inicia o mvc para realizar um insert de tarefas
   * na widget de Evolução
   *
   * @param {object} widget widget Evolução
   * para pegar a currentRow.
   *
   * @return {object} (deferred | restEngine) retorna
   * a promisse da finalização da inserção da tarefa,
   * ou a promisse da finalização da execução função.
   */
  this.insertRowNextTask = function (widget) {
    var currentRow = widget.currentRow;
    var deferred = ZHPromise.defer();

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (currentRow.DTPLANFILACONTA && !currentRow.NEXTTASKBLOCKED) {
      return ger00004500_Prospect_Service.callForInsertProspect(
        widget.currentRow
      );
    }

    deferred.resolve();
    return deferred;
  };

  /**
   * Inicia o mvc para realizar um insert de tarefas
   * na widget de Evolução
   */
  this.evolucaoNewRow = function () {
    var widget;

    widget = templateManager.container.getActiveWidget();

    if (
      !Util.isEmptyOrBlank(templateManager.container.getWidget("evolucaoOport"))
    ) {
      widget = templateManager.container.getWidget("evolucaoOport");
    } else if (
      !Util.isEmptyOrBlank(templateManager.container.getWidget("evolucao"))
    ) {
      widget = templateManager.container.getWidget("evolucao");
    }

    General.widgetNewRow(widget);

    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
      ? currentRow.DTHREVOLCONT
      : moment(new Date()).format("DD/MM/YYYY HH:mm");
    currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRORG = loggedOperatorInfos.NRORG;

    ABEvolucaoController.setEvolDateChangePermission(widget);
    this.setOperatorNextTask(currentRow, loggedOperatorInfos);

    currentRow.DTINCLUSAO = self.momentNow();
    currentRow.NRSEQCONTATO = widget.getParent().currentRow.NRSEQCONTATO;

    currentRow.NRORG = loggedOperatorInfos.NRORG;
  };

  /**
   * Seta o operador para preparar a proxima tarefa
   * da widget de evolução
   *
   * @param {object} currentRow pega a currentRow
   * da evolução
   *
   * @param {object} loggedOperatorInfos objecto com
   * as informações do operador logado.
   */
  this.setOperatorNextTask = function (currentRow, loggedOperatorInfos) {
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
  };

  this.setContactReasonFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  this.setInterlocutorFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var parentWidgetCurrentRow = field.widget.getParent().currentRow;

    var nrnparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "NRPARCNEGOCIO"
    );

    fieldFilter[nrnparcnegocioFilterIndex].value =
      parentWidgetCurrentRow.NRPARCNEGOCIO;

    field.reload();
  };

  this.setResultFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var cdoperadorFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_CDOPERADOR"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  /**
   * Organiza os campos para salvar a tarefa
   * e salva a evolução.
   *
   * @param {object} widget widget de evolução
   */
  this.saveTask = function (widgetName) {
    var widget = templateManager.container.getWidget(widgetName);
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                  if (widget.currentRow.__is_new) {
                    widget.currentRow.NRORGINCLUSAO = loggedOperatorInfos.NRORG;
                    widget.currentRow.CDOPERINCLUSAO =
                      loggedOperatorInfos.CDOPERADOR;
                    widget.currentRow.NRORGULTATU = null;
                    widget.currentRow.CDOPERULTATU = null;
                  } else {
                    widget.currentRow.NRORGULTATU = loggedOperatorInfos.NRORG;
                    widget.currentRow.CDOPERULTATU =
                      loggedOperatorInfos.CDOPERADOR;
                  }

                  widget.currentRow.CDFILIAL = "";
                  widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
                  widget.currentRow.NRSEQCLASSIFICATAREFA = widget.currentRow
                    .NRSEQCLASSIFICATAREFA
                    ? widget.currentRow.NRSEQCLASSIFICATAREFA
                    : null;

                  widget.currentRow.TIPO = "PARCEIRO";

                  widget.currentRow.NMPARCNEGOCIO = widget.getParent().currentRow.NMFANTPROS;
                  widget.currentRow.DESCRICAO =
                    "Referente ao Prospect " + widget.currentRow.NMPARCNEGOCIO;
                  widget.currentRow.NMOPERREAL = widget.currentRow.NMOPERADOR;
                  widget.currentRow.OPERADORDOLOGADO =
                    widget.currentRow.NMPARCRESP;

                  this.selectProspectContato(widget).then(
                    function (response) {
                      widget.currentRow.NRSEQCONTATO =
                        response.dataset.DADOS.NRSEQCONTATO;

                      return General.widgetSave(widget).then(
                        function (response) {
                          if (Boolean(response.dataset.DADOS)) {
                            widget.currentRow.NRSEQFILACONTA =
                              response.dataset.DADOS[0].NRSEQFILACONTA;
                          }
                          if (
                            widget.currentRow.CDOPERINCLUSAO !=
                              widget.currentRow.CDOPERREAL &&
                            !Util.isEmptyOrBlank(widget.currentRow.DSEMAILOPER)
                          ) {
                            ScreenService.confirmMessage(
                              "Deseja enviar um e-mail para o operador responsável da tarefa?",
                              "QUESTION",
                              function (yes) {
                                var params = {
                                  requestType: "Row",
                                  row: widget.currentRow,
                                };

                                restEngine
                                  .post("/enviaEmailTarefa", params)
                                  .then(() => {
                                    ScreenService.showMessage(
                                      "E-mail enviado com sucesso!"
                                    );
                                  })
                                  .catch(function (error) {
                                    if (error.data.error) {
                                      ScreenService.showMessage(
                                        "O e-mail não pode ser enviado pois as configurações de SMTP estão desconfiguradas ou erradas!",
                                        "ERROR"
                                      );
                                    } else {
                                      ScreenService.showMessage(
                                        error.data.error
                                      );
                                    }
                                  });
                              }.bind(this)
                            );
                          }
                          widget.reload();
                        }.bind(this)
                      );
                    }.bind(this)
                  );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Organiza os campos para salvar a evolução
   * e verifica tarefa já aberta.
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolucao = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    if (Util.isEmptyOrBlank(nrParcNegocio)) {
      nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
      currentRow.NRPARCNEGOCIO = nrParcNegocio;
    }

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.isValid()) {
                  var currentRow = widget.currentRow;

                  currentRow.IDGERAFATURA = "NAO";
                  currentRow.IDTPEVOLCONT = "P";
                  currentRow.IDANEXOEVOLCONT =
                    currentRow.IDANEXOEVOLCONT === "S"
                      ? currentRow.IDANEXOEVOLCONT
                      : "N";
                  currentRow.IDSENEVOCONT = Util.isEmptyOrBlank(
                    currentRow.IDSENEVOCONT
                  )
                    ? "S"
                    : currentRow.IDSENEVOCONT;
                  currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
                  widget.currentRow.CRM_NRORGTRAB = getLocalVar(
                    "CRM_NRORGTRABALHO"
                  );
                  currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;

                  currentRow.CDFILIAL = "";

                  if (!currentRow.NRRELACIONAPARC) {
                    currentRow.NRRELACIONAPARC = null;
                  }

                  this.cleanTaskGroupIfInvisible(widget, "AGENDAR_TAREFA");

                  this.selectProspectContato(widget).then(
                    function (response) {
                      if (currentRow.__is_new) {
                        this.getParentField(
                          widget,
                          response.dataset.DADOS.NRSEQCONTATO
                        );
                      }
                      this.verificaTarefasAbertas(currentRow).then(
                        function (response) {
                          if (response.dataset.DADOS.TAREFAS) {
                            var tarefas = response.dataset.DADOS.TAREFAS;
                            var operadores = "";
                            tarefas.forEach(function (tarefa) {
                              operadores += "<br>" + tarefa;
                            });
                            ScreenService.confirmMessage(
                              'Este parceiro possui tarefas "Em Aberto" para o(s) seguinte(s) operador(es) <br>' +
                                operadores +
                                "<br><br> Deseja continuar? ",
                              "CONFIRMATION",
                              function (success) {
                                this.saveEvolutionAndInsertTask(
                                  widget,
                                  currentRow
                                );
                              }.bind(this),
                              function (fail) {
                                General.widgetCancelForm(widget);
                              }
                            );
                          } else {
                            this.saveEvolutionAndInsertTask(widget, currentRow);
                          }
                        }.bind(this)
                      );
                    }.bind(this)
                  );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.cleanTaskGroupIfInvisible = function (widget, taskGroupName) {
    var taskGroup = widget.fieldGroups.find((x) => x.name == taskGroupName);
    var currentRow = widget.currentRow;

    // Não limpa os campos se o grupo de próxima tarefa estiver visível
    //(resultado parametrizado para gerar tarefa)
    if (taskGroup.isVisible) return;

    var valuesToClean = [
      "DTPLANFILACONTA",
      "NMOPERADORREAL",
      "CDOPERREAL",
      "DSCLASSIFICATAREFA",
      "DSFILACONTATO",
      "NMPRIORFILACONT",
      "NRPRIORFILACONT",
      "DSEMAILOPER",
    ];

    // "Remove" da current row todos os valores inseridos por campos
    //pertencentes ao grupo de próxima tarefa
    valuesToClean.forEach(function (valueName) {
      currentRow[valueName] = "";
    });
  };

  /**
   * Salva evolução e gera Tarefa
   *
   * @param {object} widget widget de evolução
   */
  this.saveEvolutionAndInsertTask = function (widget, currentRow) {
    this.insertRowNextTask(widget).then(
      function (response) {
        if (response) {
          currentRow.NRSEQFILACONTA = response.dataset.DADOS.NRSEQFILACONTA;
        } else if (!currentRow.NRSEQFILACONTA) {
          currentRow.NRSEQFILACONTA = "";
        }

        General.widgetSave(widget)
          .then(
            function (response) {
              this.cleanNextTaskFieldValues(widget);

              //Se a evolução é de qualificação
              if (widget.SET_QUALIFICADO) {
                this.callSetIdQualificadoProspect(widget.SET_QUALIFICADO);
                delete widget.preventLoad;
                delete widget.SET_QUALIFICADO;
              }
              if (
                !Util.isEmptyOrBlank(widget.currentRow.NRSEQINTERLOCUTOR) &&
                widget.currentRow.IDENVIAEMAIL === "S"
              ) {
                ScreenService.confirmMessage(
                  "Deseja enviar um email para " +
                    widget.currentRow.NMINTERLOCUTOR +
                    "?",
                  "QUESTION",
                  function (yes) {
                    evolutionTabController.openWidgetSendMail(widget);
                  }
                );
              }
              widget.reload();
              this.setTaskEndDate(widget);
            }.bind(this)
          )
          .catch(function (error) {
            if (error.indexOf("REQUIRE_INTERLOCUTOR") !== -1)
              ScreenService.showMessage(
                "Operação bloqueada! <br><br> Favor informar o interlocutor."
              );
            else ScreenService.showMessage(error);
          });
      }.bind(this)
    );
  };

  /**
   * Verifica se já existem tarefas relacionadas
   * aquele parceiro
   *
   * @param {object} widget widget de evolução
   */
  this.verificaTarefasAbertas = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/verificaTarefas", paramsRestEngine);
  };

  /**
   * Função para pegar as informações da tarefa
   * na widget de evolução e setar a data de
   * conclusão da tarefa no registro da própria
   * tarefa.
   *
   * @param {object} widget widget ativa que contém
   * as informações da taréfa que será concluida.
   */
  this.setTaskEndDate = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                if (widget.COMPLETETASK) {
                  ger00004500_Prospect_Service
                    .callForSetTaskEndDate(widget)
                    .then(
                      function () {
                        ScreenService.showMessage(
                          "Tarefa Concluída com sucesso."
                        );
                        this.deleteTaskInfosInEvolutionWidget(widget);
                        this.activateTaskWidget();
                      }.bind(this)
                    );
                }
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Função para ativar a widget de agenda
   * de tarefas.
   */
  this.activateTaskWidget = function () {
    var taskWidget = templateManager.container.getWidget("posvendagrid");

    taskWidget.activate();
  };

  /**
   * Função para deletar as informações da
   * tarefa a ser concluída da widget de evolução.
   *
   * @param {object} widget widget de evolução.
   */
  this.deleteTaskInfosInEvolutionWidget = function (widget) {
    delete widget.COMPLETETASK;
    delete widget.NRSEQFILACONTA;
  };

  /**
   * Seta o operador para preparar a proxima tarefa
   * da widget de evolução
   *
   * @param {object} currentRow pega a currentRow
   * da evolução
   */
  this.getParentField = function (widget, nrseqcontato) {
    widget.currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;
    widget.currentRow.NRSEQCONTATO = nrseqcontato;
    widget.currentRow.NRCONTATO = nrseqcontato;
  };

  /**
   * Inicia o mvc para realizar select de CONTATO
   *
   * @param {object} widget widget para passar a currentRow
   */
  this.selectProspectContato = function (widget) {
    return ger00004500_Prospect_Service.callForSelectProspect(
      widget.currentRow
    );
  };

  /**
   * Inicia a adição de uma nova tarefa na Agenda de tarefas
   *
   */
  this.taskScheduleNewRow = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    var currentRow = widget.currentRow;

    currentRow.NRSEQCLASSIFICATAREFA = "";
    currentRow.DTPLANFILACONTA = currentRow.DTPLANFILACONTA
      ? currentRow.DTPLANFILACONTA
      : moment(new Date()).format("DD/MM/YYYY HH:mm");
    currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.NRPARCNEGOCIO = widget.getParent().currentRow.NRPARCNEGOCIO;

    this.selectProspectContato(widget).then(
      function (response) {
        this.getParentField(widget, response.dataset.DADOS.NRSEQCONTATO);

        currentRow.NMPRINCIPALPARC = "";
        currentRow.DSEMAILTAREFA = "";
        currentRow.DSTELEFONETAREFA = "";
      }.bind(this)
    );
  };

  this.actionsNewRow = function (widName) {
    var widget = templateManager.container.getActiveWidget();
    var currentRow = widget.currentRow;
    var nrParcNegocio = templateManager.container.getActiveWidget().currentRow
      .NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
      if (currentRow.IDATIVO === "S") {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                this.closeActionsPopup().then(
                  function () {
                    var widget = templateManager.container.getWidget(widName);
                    this.activateWidget(widget).then(
                      function () {
                        setTimeout(function () {
                          widget.newRow();
                        }, 100);
                      }.bind(this)
                    );
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      } else {
        ScreenService.showMessage(
          "Operação Bloqueada Pois o Prospect se encontra Inativo!<br>" + "<br>Gentileza Procurar a Equipe de Qualidade Para Ativação do Prospect"
        );
      }
    });
  };

  this.actionEvolutionNewRow = function (widName) {
    this.closeActionsPopup().then(
      function () {
        var widget = templateManager.container.getWidget(widName);

        this.activateWidget(widget).then(
          function () {
            setTimeout(
              function () {
                this.evolucaoNewRow();
              }.bind(this),
              100
            );
          }.bind(this)
        );
      }.bind(this)
    );
  };

  this.closeActionsPopup = function () {
    var deferred = ZHPromise.defer();
    ScreenService.closePopup();
    deferred.resolve();
    return deferred;
  };

  this.activateWidget = function (widget) {
    var deferred = ZHPromise.defer();
    widget.activate();
    deferred.resolve();
    return deferred;
  };

  this.filterOnOpenEvol = function (widget) {
    this.selectProspectContato(widget).then(
      function (response) {
        var widDataSource = widget.dataSourceFilter;

        var nrseqcontatoFilter = CRM_Utilities.getFilterPosition(
          widDataSource,
          "NRSEQCONTATO"
        );

        widDataSource[nrseqcontatoFilter].value =
          response.dataset.DADOS.NRSEQCONTATO;
        //widget.reload();
      }.bind(this)
    );
  };

  this.setEvolutionWidgetFilter = function (widget) {
    var widgetFilter = widget.dataSourceFilter;
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    var parcFilter = widgetFilter.find((x) => x.name == "P_NRPARCNEGOCIO");
    var nrorgFilter = widgetFilter.find((x) => x.name == "P_NRORG");

    parcFilter.value = parentWidgetCurrentRow.NRPARCNEGOCIO;
    nrorgFilter.value = parentWidgetCurrentRow.NRORG;

    if (widget.container.name == "crm33000_000_assistente_de_agendamento") {
      this.verifyFilterAssistant(widget);
    }

    if (!widget.preventLoad) {
      widget.reload();
    }
  };

  this.setNextTaskDefaultValues = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;

    currentRow.DTPLANFILACONTA = moment(new Date()).format(
      "DD/MM/YYYY HH:mm:ss"
    );
    currentRow.NRPRIORFILACONT = 2;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
  };

  this.setNextTaskVisibility = function (widget, taskGroupName) {
    // Pega o grupo de campos relacionado à próxima tarefa
    var taskGroup = widget.fieldGroups.find((x) => x.name == taskGroupName);

    // Se o resultado selecionado estiver parametrizado para gerar tarefa,
    // o grupo ficará visível. Caso contrário, ficará invisível
    var geraProxTarefa = widget.currentRow.IDGERPROXATIV === "S";

    var taskFields = widget.fields.filter((x) => x.fieldGroup == taskGroupName);

    taskFields.forEach(function (field) {
      field.isVisible = geraProxTarefa;
      field.readOnly = !geraProxTarefa;
    });

    taskGroup.isVisible = geraProxTarefa;
  };

  this.reloadTab = function (widget) {
    if (
      widget.currentFilter &&
      widget.currentFilter !== widget.getParent().currentRow.NRPARCNEGOCIO
    )
      widget.reload();
    else if (!widget.currentFilter) widget.reload();

    this.setCurrentFilter(widget);
  };

  this.setCurrentFilter = function (widget) {
    widget.currentFilter = widget.getParent().currentRow.NRPARCNEGOCIO;
  };

  this.setOpportunityWidgetFilter = function (widget) {
    var widgetFilter = widget.dataSourceFilter;
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    var nrseqcontatoFilterIndex = CRM_Utilities.getFilterPosition(
      widgetFilter,
      "NRPARCOPORT"
    );

    widgetFilter[nrseqcontatoFilterIndex].value =
      parentWidgetCurrentRow.NRPARCNEGOCIO;

    this.reloadTab(widget);
  };

  this.getProspectNrSeqContato = function (widget) {
    this.selectProspectContato(widget).then(function (response) {
      widget.currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
    });
  };

  this.setResponsibleOperatorFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;

    var nrorgFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRORG"
    );
    var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "P_NRPARCNEGOCIO"
    );
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
    fieldFilter[nrparcnegocioFilterIndex].value =
      loggedOperatorInfos.CDOPERADOR;

    field.reload();
  };

  this.setValuesForNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var parentWidgetCurrentRow = widget.getParent().currentRow;

    currentRow.CDFILIAL = "";
    currentRow.NRSEQFASENEGO = "";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.NMPARCRESP = loggedOperatorInfos.NMOPERADOR;
    currentRow.CDOPERCONT = loggedOperatorInfos.CDOPERADOR;
    currentRow.NRPARCRESP = loggedOperatorInfos.NRPARCNEGOCIO;
    if (!Util.isEmptyOrBlank(parentWidgetCurrentRow.NMRAZSOCPROS)) {
      currentRow.NMPRINCIPALPARC = parentWidgetCurrentRow.NMRAZSOCPROS;
    } else if (!Util.isEmptyOrBlank(parentWidgetCurrentRow.NMRAZSOCCLIE)) {
      currentRow.NMPRINCIPALPARC = parentWidgetCurrentRow.NMRAZSOCCLIE;
    }
    currentRow.NRPARCOPORT = parentWidgetCurrentRow.NRPARCNEGOCIO;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;

    this.setNegotiationPhaseLock(widget, false);
  };

  this.editTask = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.editOppotunity = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              this.setNegotiationPhaseLock(widget, true);

              General.widgetEdit(widget);
              this.disableSituacaoOport(widget);
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  this.saveOpportunity = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              if (widget.currentRow.__is_new) {
                this.saveNewOpportunity(widget);
              } else {
                this.saveEditionOpportunity(widget);
              }
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  this.saveNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var newRow = currentRow.__is_new;

    this.removeOpportunityValueMask(currentRow);
    this.setColumsToReturnInCurrentRow(currentRow, [
      "NRSEQOPORT",
      "NRSEQCONTATO",
      "NRCONTATO",
    ]);

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    General.widgetSave(widget).then(
      function (response) {
        currentRow.NRSEQOPORT = response.dataset.DADOS.NRSEQOPORT;
        currentRow.NRSEQCONTATO = response.dataset.DADOS.NRSEQCONTATO;
        currentRow.NRCONTATO = response.dataset.DADOS.NRCONTATO;

        if (newRow) {
          CRM_Utilities.reloadGridInViewMode(widget);
        }

        ScreenService.showMessage(
          "Número da Oportunidade: " + parseInt(currentRow.NRSEQOPORT)
        ).then(function () {
          widget.list();
          var widgetCompromisso = templateManager.container.getWidget(
            "compromissoOportunidade"
          );
          var widgetOportunidade = templateManager.container.getWidget(
            "oportunidadegrid"
          );
          crm00002001_OportunidadeNegocio_Controller.verificaNovoCompromisso(
            widgetCompromisso,
            widgetOportunidade
          );
        });
      }.bind(this)
    );
  };

  this.saveEditionOpportunity = function (widget) {
    var currentRow = widget.currentRow;

    this.removeOpportunityValueMask(currentRow);

    General.widgetSave(widget);
  };

  this.removeOpportunityValueMask = function (currentRow) {
    currentRow.VROPORT = CRM_Utilities.removeValueCurrencyMask(
      currentRow.VROPORT
    );
    currentRow.VRPREVOPORT = CRM_Utilities.removeValueCurrencyMask(
      currentRow.VRPREVOPORT
    );
  };

  this.setColumsToReturnInCurrentRow = function (currentRow, arrayColumns) {
    currentRow.__columns_to_return = arrayColumns;
  };

  this.insertNrseqcontatoForNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;

    ger00004500_Prospect_Service.callForInsertNrseqcontatoForNewOpportunity(
      currentRow
    );
  };

  this.convertProspectIntoClient = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var parcPosicionado = widget.currentRow.NRPARCNEGOCIO;
                General.callRestEngine(
                  "product#/verifyParcGroupRel",
                  "DataSet",
                  [currentRow]
                ).then((response) => {
                  if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, "ERROR");
                  }
                  if (
                    response.dataset &&
                    !Util.isEmptyOrBlank(response.dataset.RELATIONSHIP)
                  ) {
                    ScreenService.confirmMessage(
                      response.dataset.RELATIONSHIP.PAI.NRINSCRICAOPARC +
                        ` – ` +
                        response.dataset.RELATIONSHIP.PAI.NMPRINCIPALPARC +
                        ` possui parceiros relacionados. 
                                Deseja criar uma evolução para os parceiros relacionados alterando o status destes parceiros para a organização ` +
                        templateManager.LOGGEDOPERATOR.CRM_NRORGTRAB +
                        ` - ` +
                        templateManager.LOGGEDOPERATOR.NMORGTRAB,
                      "CONFIRMATION",
                      () => {
                        this.callPopupPartnerRelated(
                          response.dataset.RELATIONSHIP
                        );
                      }
                    );
                  } else {
                    this.callToConvertProspect(widget, parcPosicionado);
                  }
                });
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Verifica se já existem clientes vinculados
   * com aquele CNPJ
   */
  this.validacaoCNPJCliente = function (CNPJ, NRORG) {
    var paramsRestEngine = {
      requestType: "Row",
      row: {
        CNPJ: CNPJ,
        NRORG: NRORG,
        CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
      },
    };
    return restEngine.post("/validaCNPJCliente", paramsRestEngine);
  };

  this.updatePartnerType = function (currentRow) {
    ger00004500_Prospect_Service.callForUpdatePartnerType(currentRow);
  };

  this.insertPartnershipOfTypeClient = function (currentRow) {
    ger00004500_Prospect_Service.callForInsertPartnershipOfTypeClient(
      currentRow
    );
  };

  this.insertClient = function (currentRow) {
    return ger00004500_Prospect_Service.callForInsertClient(currentRow);
  };

  this.insertClientAddress = function (currentRow) {
    this.selectProspectAddress(currentRow).then(function (response) {
      var address = response.dataset.DADOS.ADDRESS;

      address.forEach(function (addressObject) {
        var reserveCurrentRow = currentRow;

        reserveCurrentRow.NRENDERECOPARC = addressObject.NRENDERECOPARC;
        reserveCurrentRow.CDPAIS = addressObject.CDPAIS;
        reserveCurrentRow.SGESTADO = addressObject.SGESTADO;
        reserveCurrentRow.CDMUNICIPIO = addressObject.CDMUNICIPIO;
        reserveCurrentRow.CDBAIRRO = addressObject.CDBAIRRO;
        reserveCurrentRow.DSENDECLIE = addressObject.DSENDEPROS;
        reserveCurrentRow.IDTPENDECLIE = addressObject.IDTPENDEPROS;
        reserveCurrentRow.NMBAIRCLIE = addressObject.NMBAIRPROS;
        reserveCurrentRow.DSCOMPENDCLI = addressObject.DSCOMPENDPRO;
        reserveCurrentRow.NRCEPCLIE = addressObject.NRCEPPROS;
        reserveCurrentRow.NRTELECLIE = addressObject.NRTELEPROS;
        reserveCurrentRow.NRRAMALCLIE = addressObject.NRRAMALPROS;
        reserveCurrentRow.DSEMAILCLIE = addressObject.DSEMAILPROS;

        ger00004500_Prospect_Service.callForInsertClientAddress(
          reserveCurrentRow
        );
      });
    });
  };

  this.selectProspectAddress = function (currentRow) {
    return ger00004500_Prospect_Service.callForSelectProspectAddress(
      currentRow
    );
  };

  this.deactivateProspect = function (currentRow) {
    ger00004500_Prospect_Service.callForDeactivateProspect(currentRow);
  };

  this.setEvolutionInterlocutorFieldFilter = function (field) {
    var fieldFilter = field.dataSourceFilter;
    var prospectPartnershipNumber = field.widget.getParent().currentRow
      .NRPARCNEGOCIO;

    var nrparcnegocioFilterIndex = CRM_Utilities.getFilterPosition(
      fieldFilter,
      "NRPARCNEGOCIO"
    );

    fieldFilter[nrparcnegocioFilterIndex].value = prospectPartnershipNumber;

    field.reload();
  };

  /**
   * Função para possibilitar o cadastro de
   * uma evolução referente a tarefa em caso,
   * indicando a conclusão da tarefa.
   *
   * @param {object} widget widget ativa, no modo
   * view, referente a tarefa em caso.
   */
  this.completeTask = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    var evolutionWidget = templateManager.container.getWidget("evolucao");
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                evolutionWidget.COMPLETETASK = true;
                evolutionWidget.NRSEQFILACONTA =
                  widget.currentRow.NRSEQFILACONTA;

                ScreenService.closeSwipe().then(
                  function () {
                    this.activateWidget(evolutionWidget).then(
                      function () {
                        setTimeout(
                          function () {
                            this.evolucaoNewRow();
                          }.bind(this),
                          500
                        );
                      }.bind(this)
                    );
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Função para abrir a widget de seleção
   * de arquivos.
   */
  this.openAnnexSwipe = function () {
    var fileUploadWidget = templateManager.container.getWidget(
      "WDGT_SELECAO_ARQUIVOS"
    );
    var nrParcNegocio = fileUploadWidget.getParent().getParent().getParent()
      .currentRow.NRPARCNEGOCIO;
    var currentRow = fileUploadWidget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                fileUploadWidget.isVisible = true;
                ScreenService.openSwipe(fileUploadWidget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Função para salvar os anexos selecionados
   * ao caso em questão.
   *
   * @param {object} widget widget onde é
   * feito a seleção dos anexos.
   */
  this.uploadEvolutionFiles = function (widget) {
    var nrParcNegocio = widget.getParent().getParent().getParent().currentRow
      .NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var files = widget.currentRow.DSCAMINHO;
                var rows = [];

                files.forEach(
                  function (file, fileIndex) {
                    rows.push(this.setValuesForFileUpload(widget, fileIndex));
                  }.bind(this)
                );

                General.callRestEngine(
                  "product#/crm_anexocontato/save",
                  "DataSet",
                  rows
                ).then(
                  function () {
                    this.closeAnnexSwipe(widget);
                    widget.getParent().reload();
                    widget.parent.parent.reload();
                  }.bind(this)
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Função para retornar uma row configurada
   * com as informações do anexo referente
   * ao ID, recebido como parâmetro, no array
   * de anexos na currentRow.
   *
   * @param {object} widget widget onde foi selecionado
   * os anexos.Array
   *
   * @param {int} fileIndex index do anexo no array de
   * anexos presente na currentRow.
   *
   * @return {object} currentRow row configurada com as informações
   * do anexo referente ao ID recebido.
   */
  this.setValuesForFileUpload = function (widget, fileIndex) {
    var currentRow = angular.copy(widget.currentRow);
    var evolutionWidget = widget.getParent().getParent();
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.NRSEQCONTATO =
      evolutionWidget.parent.parent.currentRow.NRSEQCONTATO;
    currentRow.NMARQUIVO = this.getFileNameWithoutExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.DSTIPO = this.getFileExtension(
      currentRow.DSCAMINHO[fileIndex].name
    );
    currentRow.VRTAMANHO = currentRow.DSCAMINHO[fileIndex].size;
    currentRow.IDATIVO = "S";
    currentRow.NRORG = loggedOperatorInfos.NRORG;
    currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
    currentRow.IDORIGEM = "EVOLUCAO";
    currentRow.NRORIGEM = evolutionWidget.currentRow.NRSEQEVOLCONT;

    return currentRow;
  };

  /**
   * Função para retornar a extenção de um arquivo
   * extraida do seu nome.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$2");
  };

  /**
   * Função para retornar o nome do arquivo sem
   * sua extenção.
   *
   * @param {string} fileName nome completo do arquivo.
   */
  this.getFileNameWithoutExtension = function (fileName) {
    return fileName.replace(/^(.*)\.(.*)$/, "$1");
  };

  /**
   * Função para fechar o swipe de upload de imagens.
   *
   * @param {object} widget widget de upload de imagens.
   */
  this.closeAnnexSwipe = function (widget) {
    ScreenService.closeSwipe().then(function () {
      widget.isVisible = false;
      widget.getParent().list();
      widget.getParent().activate();
    });
  };

  /**
   * Função para fazer o download de uma arquivo
   * salvo no servidor.
   *
   * @param {object} widget widget que contém
   * as informações do arquivo a ser baixado
   * em sua currentRow.
   */

  this.downloadFile = function (widget) {
    window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHO);
  };

  this.deleteAttachment = function (widget) {
    var nrParcNegocio = widget.getParent().getParent().currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.deleteCrud(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  /**
   * Função para resetar as informações
   * de criação de uma nova tarefa(a partir de uma
   * evolução).
   *
   * @param {object} widget widget de evolução, que terá
   * as informações resetadas.
   */
  this.resetNewTaskInfos = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    currentRow.DTPLANFILACONTA = "";
    currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
    currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
    currentRow.NRPRIORFILACONT = 2;
  };

  /**
   * Função para deletar uma evolução e
   * seus anexos.
   *
   * @param {object} widget widget ativa, no
   * modo view, mostrando os dados da evolução
   * que será deletada.
   */
  this.deleteEvolution = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.NRORIGEM = currentRow.NRSEQEVOLCONT;

    General.deleteCrud(widget).then(
      function () {
        this.deleteEvolutionFilesByOriginNumber(widget);
      }.bind(this)
    );
  };

  /**
   * Função para deletar os anexos de uma evolução
   * pelo número de origem do anexo.
   *
   * @param {object} widget widget ativa, no
   * modo view, mostrando os dados da evolução
   * que será deletada.
   */
  this.deleteEvolutionFilesByOriginNumber = function (widget) {
    return ger00004500_Prospect_Service.callForDeleteEvolutionFilesByOriginNumber(
      widget
    );
  };

  /**
   * Função para checar a permissão para gerar
   * uma nova tarefa a partir de uma nova evolução.
   *
   * @param {object} widget widget ativa, no modo
   * edit, onde está sendo cadastrado a evolução.
   */
  this.checkNewTaskPermissionByEvolutionResult = function (widget) {
    var currentRow = widget.currentRow;
    var dataProximaTarefa = widget.getField("DTPLANFILACONTA");

    if (
      currentRow.IDGERPROXATIV &&
      currentRow.IDGERPROXATIV === "S" &&
      !currentRow.NEXTTASKBLOCKED
    ) {
      this.setNewTaskPermission(widget, true);
      dataProximaTarefa.validations = { required: true };
    } else {
      this.setNewTaskPermission(widget, false);
      dataProximaTarefa.validations = {};
    }
  };

  /**
   * Função para setar a permissão de criar uma nova
   * tarefa a partir do resultado da evolução.
   *
   * @param {object} widget widget ativa, no modo edit,
   * onde está sendo cadastrado a evolução.
   *
   * @param {boolean} isAllowed permissão booleana do
   * cadastro da tarefa.
   */
  this.setNewTaskPermission = function (widget, isAllowed) {
    if (isAllowed) {
      this.setTaskFieldLock(widget, false);

      widget.currentRow.DTPLANFILACONTA = "";
    } else {
      this.setTaskFieldLock(widget, true);
    }
  };

  /**
   * Função para definir o bloqueio dos campos
   * de agenda de tarefa na widget de evolução.
   *
   * @param {object} widget widget de evolução,
   * onde estão os campos para criar um nova
   * tarefa.
   *
   * @param {boolean} isLocked estado dos campos.
   */
  this.setTaskFieldLock = function (widget, isLocked) {
    var nextTaskDate = widget.getField("DTPLANFILACONTA");
    var taskOperator = widget.getField("NMOPERADORREAL");
    var taskDescription = widget.getField("DSFILACONTATO");
    var taskClassification = widget.getField("DSCLASSIFICATAREFA");
    var taskPriority = widget.getField("NRPRIORFILACONT");

    this.setFieldLock(nextTaskDate, isLocked, widget);
    this.setFieldLock(taskOperator, isLocked, widget);
    this.setFieldLock(taskDescription, isLocked, widget);
    this.setFieldLock(taskClassification, isLocked, widget);
    this.setFieldLock(taskPriority, isLocked, widget);
  };

  /**
   * Função para editar uma evolução.
   *
   * @param {object} widget widget ativa, no
   * modo de visualização, com as informações
   * da evolução a ser editada.
   */
  this.editEvolution = function (widget) {
    General.widgetEdit(widget);

    widget.getField("NMRESULTEVOL").readOnly = true;
    widget.getField("DTPLANFILACONTA").validations = {};

    ABEvolucaoController.setEvolDateChangePermission(widget);
    this.checkPermissionToCreateNewTaskInEvolutionEdition(widget);
  };

  /**
   * Função para verificar a permissão para inserir
   * uma nova tarefa na edição da evolução em caso.
   *
   * @param {object} widget widget ativa, no modo de
   * edição, com as informações da evolução em edição.
   */
  this.checkPermissionToCreateNewTaskInEvolutionEdition = function (widget) {
    var currentRow = widget.currentRow;

    if (currentRow.DTPLANFILACONTA) {
      this.setTaskFieldLock(widget, true);

      currentRow.NEXTTASKBLOCKED = true;
    } else {
      this.unlockNextTask(widget);
      this.checkNewTaskPermissionByEvolutionResult(widget);
      this.resetNewTaskInfos(widget);
    }
  };

  /**
   * Função para liberar o cadastro de uma
   * nova tarefa a partir de um evolução,
   * excluindo o parâmetro de bloqueio.
   *
   * @param {object} widget widget de evolução.
   */
  this.unlockNextTask = function (widget) {
    if (widget.currentRow.NEXTTASKBLOCKED) {
      delete widget.currentRow.NEXTTASKBLOCKED;
    }
  };

  /**
   * Função para limpar os valores dos campos
   * para gerar uma nova tarefa através de uma
   * evolução.onmessage.
   *
   * @param {object} widget widget de evolução.
   */
  this.cleanNextTaskFieldValues = function (widget) {
    var currentRow = widget.currentRow;

    if (!currentRow.DTPLANFILACONTA) {
      currentRow.DTPLANFILACONTA = "";
      currentRow.DSFILACONTATO = "";
      currentRow.NMOPERADORREAL = "";
      currentRow.NRPRIORFILACONT = "";
    }
  };

  /**
   * Função para deletar uma tarefa,
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, mostrando a tarefa a ser deletada.
   */
  this.deleteTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
      if (canEdit) {
        General.callRestEngine("product#/verifyGroupRel", "DataSet", [
          currentRow,
        ]).then(
          function (response) {
            if (response.dataset && response.dataset.error) {
              ScreenService.showMessage(response.dataset.error, "ERROR");
            }
            if (response.dataset && response.dataset.GROUPREL[0] == false) {
              General.deleteCrud(widget)
                .then(function () {})
                .catch(
                  function () {
                    ScreenService.confirmMessage(
                      ScreenService.i18n(
                        Messages.EXCLUSAO_TAREFA_VINC_EVOLUCAO
                      ),
                      "question",
                      function (success) {
                        this.deactivateTask(widget)
                          .then(function () {
                            ScreenService.showMessage(
                              Messages.TAREFA_INATIVADA
                            );

                            ScreenService.closeSwipe().then(function () {
                              widget.reload();
                            });
                          })
                          .catch(function (error) {
                            ScreenService.showMessage(
                              Messages.CATCH_EXCEPTION_ERROR(error.data.error)
                            );
                          });
                      }.bind(this),
                      function (error) {}
                    );
                  }.bind(this)
                );
            } else {
              ScreenService.showMessage(
                "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                  response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                  " - " +
                  response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                  "!"
              );
            }
          }.bind(this)
        );
      } else {
        this.showMessageCantEditParc();
      }
    });
  };

  /**
   * Função para desativar a tarefa em caso.
   *
   * @param {object} widget widget ativa, no modo
   * de visualização, com as informações da tarefa
   * a ser desativada.
   */
  this.deactivateTask = function (widget) {
    return ger00004500_Prospect_Service.callForDeactivateTask(widget);
  };

  /**
   * Função para setar o bloqueio de um campo.
   *
   * @param {object} field field a ser manipulada.
   *
   * @param {boolean} isLocked variável que apontará
   * se o campo será bloqueado ou não;
   */
  this.setFieldLock = function (field, isLocked, widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    field.readOnly = isLocked;

    if (isLocked) {
      field.clearValue();
    } else {
      if (field.name == "NMOPERADORREAL") {
        currentRow.NMOPERADORREAL = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERREAL = loggedOperatorInfos.CDOPERADOR;
      } else if (field.name == "DSFILACONTATO") {
        field.value("Retornar Contato");
      }
    }
  };

  /**
   * Função para setar o bloqueio do campo 'Código'
   * na widget de interlocutores.
   *
   * @param {object} widget widget de interlocutores do prospect
   * em caso.
   *
   * @param {boolean} isLocked variável que apontará
   * se os campos serão bloqueados ou não;
   */
  this.setNegotiationPhaseLock = function (widget, isLocked) {
    var interlocCodeField = widget.getField("NMSEQFASENEGO");

    interlocCodeField.readOnly = isLocked;
  };

  /*this.setIDATIVO = function(widget) {
        var filter;
        if(widget.name !== 'gridProspect') {
            filter = templateManager.container.getWidget('gridProspect').__filterPopup;
        }else{
            filter = widget.__filterPopup;
        }
        filter.currentRow.IDATIVO = 'S';
        filter.reload();
    };*/

  /**
   * Dispara os eventos necessários no evento
   * "WidgetAfterMoveRow" da widget principal
   * (gridProspect).
   *
   * @param {object} widget widget principal da tela
   * prospect.
   */
  this.shootsMainWidgetEventsAfterMoveRow = function (widget) {
    this.setOperatorLoggedInCurrentRow();
    this.getProspectNrSeqContato(widget);
    this.hideActionsToProspectsWithCreatedOpportunity(widget);
    this.hideActionsToReservedProspects(widget);
    this.setLabelActionQualificado(widget);
    this.classConcorrente(widget);
    this.readOnlyConcorrente(widget);
  };

  /**
   * Esconde as ações quando um propect possuir
   * oportunidade criada e o operador logado não for
   * o responsável pelo prospect.
   *
   * @param {object} widget widget principal da tela de
   * prospect.
   */
  this.hideActionsToProspectsWithCreatedOpportunity = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    var currentRow = widget.currentRow;

    if (
      currentRow.POSSUIOPORTUNIDADE === "S" &&
      loggedOperatorInfos.NRPARCNEGOCIO !== currentRow.NRPARCRESPROSP
    ) {
      this.hideFunctionalActions();
      currentRow.BLOCKEDPROSPECT = true;
      ScreenService.showMessage(Messages.PROSPECT_BLOQUEADO);
    } else if (
      !Boolean(currentRow.BLOCKEDPROSPECT) ||
      currentRow.BLOCKEDPROSPECT === false
    ) {
      this.returnContainerDefaultAction(widget);
      currentRow.BLOCKEDPROSPECT = false;
    }
  };

  /**
   * Esconde as actions da tela de prospect quando
   * um prospect reservado é selecionado.
   *
   * @param {object} widget widget principal da tela
   * de prospect (gridProspect).
   *
   */
  this.hideActionsToReservedProspects = function (widget) {
    var currentRow = widget.currentRow;
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      this.isReservedProspect(widget) &&
      loggedOperatorInfos.NRPARCNEGOCIO !== currentRow.NRPARCRESPROSP
    ) {
      this.hideFunctionalActions();
      currentRow.BLOCKEDPROSPECT = true;
      ScreenService.showMessage(Messages.PROSPECT_BLOQUEADO);
    } else if (
      !Boolean(currentRow.BLOCKEDPROSPECT) ||
      currentRow.BLOCKEDPROSPECT === false
    ) {
      this.returnContainerDefaultAction(widget);
      currentRow.BLOCKEDPROSPECT = false;
    }
  };

  /**
   * Verifica se um prospect está reservado
   * de acordo com a paramentrização do CRM.
   *
   * @param {object} widget widget principal da tela
   * de prospect (gridProspect).
   */

  this.isReservedProspect = function (widget) {
    var crmParametrization = CRM_Utilities.getCrmParametrization();

    var currentRow = widget.currentRow;

    var reserveTnitDate = CRM_Utilities.subtractDateByDays(
      currentRow.DTINIRESERVAPROSP,
      1
    );
    var reserveEndDate = CRM_Utilities.addDaysToDate(
      reserveTnitDate,
      crmParametrization.NRMAXDIASPROSPBLOQ + 1,
      "DD/MM/YYYY"
    );

    var currentDate = CRM_Utilities.getDataHoraAtual();
    var formatedCurrentDate = CRM_Utilities.changeDateFormat(
      currentDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );
    var formatedReserveTnitDate = CRM_Utilities.changeDateFormat(
      reserveTnitDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );
    var formatedReserveEndDate = CRM_Utilities.changeDateFormat(
      reserveEndDate,
      "DD/MM/YYYY HH:mm",
      "YYYY-MM-DD"
    );

    return moment(formatedCurrentDate).isBetween(
      formatedReserveTnitDate,
      formatedReserveEndDate
    );
  };

  /**
   * Esconde as ações funcionais da tela.
   */
  this.hideFunctionalActions = function () {
    var containerActions = templateManager.container.actions;

    containerActions.forEach(function (action) {
      if (action.label !== "Voltar") {
        action.isVisible = false;
        action.disable = true;
      }
    });
  };

  /**
   * Retorna as configurações padrão das ações
   * do container ativo.
   *
   * @param {object} widget widget principal da tela de
   * prospect com o backup das actions.
   */
  this.returnContainerDefaultAction = function (widget) {
    var containerActions = templateManager.container.actions;

    containerActions.forEach(function (action) {
      if (Boolean(action.disable)) {
        action.isVisible = true;
        delete action.disable;
      }
    });
  };

  /**
   * Define as regras da tela de prospect de acordo
   * com a revenda do operador logado.
   *
   * @param {object} widget widget principal da tela de prospect
   * ('WDGT_ASSISTENTE_AGENDAMENTO').
   */
  this.setResaleRules = function (widget) {
    var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

    if (
      loggedOperatorInfos.IDTPOPERADOR === "R" &&
      Boolean(loggedOperatorInfos.NRREVENDA)
    ) {
      var restrictObjects = [];

      restrictObjects.push(widget);

      restrictObjects.push(widget.getField("NMPARCRESPROSP"));

      var tasksWidget = templateManager.container.getWidget("posvendagrid");
      restrictObjects.push(tasksWidget.getField("NMOPERADOR"));

      var evolutionWidget = templateManager.container.getWidget("evolucao");
      restrictObjects.push(evolutionWidget.getField("NMOPERADORREAL"));

      CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(
        restrictObjects
      );
    }
  };

  this.setLabelActionQualificado = function (widget) {
    var currentRow = widget.currentRow;
    var actionQualificar = widget.getAction("SET_QUALIFICADO");

    if (currentRow.IDQUALIFICADO === "S") {
      actionQualificar.label = "Desqualificar Prospect";
    } else {
      actionQualificar.label = "Qualificar Prospect";
    }
  };

  this.setIdQualificadoProspect = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    var actionQualificar = widget.getAction("SET_QUALIFICADO");
    var message =
      "Tem certeza que deseja " +
      actionQualificar.label.split(" ")[0].toLowerCase() +
      " o prospect: <br>" +
      currentRow.NMRAZSOCPROS +
      " ?";
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.confirmMessage(
                  message,
                  "CONFIRMATION",
                  function () {
                    var evolWidgt = templateManager.container.getWidget(
                      "evolucao"
                    );
                    widget.openTab("evolucao");

                    ScreenService.closePopup();

                    evolWidgt.getField("NMRESULTEVOL").readOnly = false;
                    evolWidgt.preventLoad = true;
                    evolWidgt.SET_QUALIFICADO = widget;

                    setTimeout(
                      function () {
                        this.evolucaoNewRow();
                      }.bind(this),
                      500
                    );
                  }.bind(this),
                  function () {
                    ScreenService.closePopup();
                  }
                );
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.callSetIdQualificadoProspect = function (widget) {
    var currentRow = widget.currentRow;

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");

    if (currentRow.IDQUALIFICADO === "S") {
      currentRow.IDQUALIFICADO = "N";
    } else {
      currentRow.IDQUALIFICADO = "S";
    }

    var parametroRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    restEngine
      .post("/setIdQualificadoProspect", parametroRestEngine)
      .then(
        function (response) {
          widget.reload();
          if (currentRow.IDQUALIFICADO === "N")
            ScreenService.showMessage("Prospect Desqualificado com Sucesso!");
          else ScreenService.showMessage("Prospect Qualificado com Sucesso!");
          this.setLabelActionQualificado(widget);
        }.bind(this)
      )
      .catch(function () {
        currentRow.IDQUALIFICADO === "N"
          ? (currentRow.IDQUALIFICADO = "S")
          : (currentRow.IDQUALIFICADO = "N");
        ScreenService.showMessage("Falha na operação!");
      });
  };

  /**
   * Executa as funções necessárias no evento
   * "WidgetOnEnterOnce" da widget de prospect.
   *
   * @param {object} widget widget de prospect
   * ("gridProspect").
   */
  this.widgetOnEnterOnce = function (
    widget,
    fieldsToApply,
    filterError = false
  ) {
    var filterRow = {};
    var wdgt = templateManager.container.getWidget("gridProspect");

    if (
      typeof templateManager !== "undefined" &&
      templateManager.LOGGEDOPERATOR
    ) {
      filterRow.NRPARCRESPROSP = [templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO];

      if (widget.name === "gridProspect")
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
      else {
        widget.dataSource.data = wdgt.dataSource.data;
        widget.appliedFilter = wdgt.appliedFilter;
      }
    }

    if (!filterError) {
      AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 3);
      ABAEnderecoParceiroController.setAddressWidgetOnActiveWidget(widget, 2);
      PartnerInfosModalController.setModalWidgetOnActiveWidget(
        widget,
        "NRPARCNEGOCIO"
      );
      ABALogotipoParceiroController.setLogoWidgetOnActiveWidget(widget, 8);

      this.setResaleRules(widget);
      this.checkParamToAddProspect(widget);
    }
  };

  this.classConcorrente = function (widget) {
    var fieldDTinicio = widget.getField("DTINIVIGENCIA");
    var fieldDTfim = widget.getField("DTFIMVIGENCIA");

    if (widget.mode === "edit") {
      fieldDTfim.class = "6";
      fieldDTinicio.class = "6";
    } else {
      fieldDTfim.class = "4";
      fieldDTinicio.class = "4";
    }
  };

  this.readOnlyConcorrente = function (widget) {
    var fieldDTinicio = widget.getField("DTINIVIGENCIA");
    var fieldDTfim = widget.getField("DTFIMVIGENCIA");

    if (Util.isEmptyOrBlank(widget.currentRow.NRCONCORRENTE)) {
      fieldDTfim.readOnly = true;
      fieldDTinicio.readOnly = true;
      fieldDTinicio.value("");
      fieldDTfim.value("");
    } else {
      fieldDTfim.readOnly = false;
      fieldDTinicio.readOnly = false;
    }
  };

  this.calculaDiasFimContrato = function (fimVigencia) {
    if (typeof fimVigencia === "string" && !Util.isEmptyOrBlank(fimVigencia)) {
      //formata data
      fimVigencia =
        fimVigencia.slice(3, 5) +
        "/" +
        fimVigencia.slice(0, 2) +
        "/" +
        fimVigencia.slice(6, 10);
      fimVigencia = new Date(fimVigencia);
      var currentDate = new Date();
      //calcula a diferencia em milesimos
      var diferenca = fimVigencia - currentDate;
      //milesimos em um dia
      var dia = 1000 * 60 * 60 * 24;

      //Se fimVigencia não for numero retorna vazio, se não retorna a diferenca limitada a zero
      return Math.round(diferenca / dia) < 0 ? 0 : Math.round(diferenca / dia);
    } else {
      return null;
    }
  };

  this.alteraEstadoReadonly = function (widget) {
    var paisField = widget.getField("NMPAIS");
    var estadoField = widget.getField("NMESTADO");
    var currentRow = widget.currentRow;
    if (!paisField.value()) {
      estadoField.readOnly = true;
      currentRow.SGESTADO = null;
      currentRow.NMESTADO = null;
    } else {
      estadoField.readOnly = false;
      currentRow.SGESTADO = null;
      currentRow.NMESTADO = null;
    }
    this.alteraMunicipioReadonly(widget);
  };

  this.alteraMunicipioReadonly = function (widget) {
    var estadoField = widget.getField("NMESTADO");
    var municipioField = widget.getField("NMMUNICIPIO");
    var currentRow = widget.currentRow;
    if (!estadoField.value()) {
      municipioField.readOnly = true;
      currentRow.NMMUNICIPIO = null;
      currentRow.CDMUNICIPIO = null;
      currentRow.NMMUNICIPIO = null;
    } else {
      municipioField.readOnly = false;
      currentRow.NMMUNICIPIO = null;
      currentRow.CDMUNICIPIO = null;
      currentRow.NMMUNICIPIO = null;
    }
    this.alteraBairroReadonly(widget);
  };

  this.alteraBairroReadonly = function (widget) {
    var municipioField = widget.getField("NMMUNICIPIO");
    var bairroField = widget.getField("NMBAIRRO");
    var currentRow = widget.currentRow;
    if (!municipioField.value()) {
      bairroField.readOnly = true;
      currentRow.NMBAIRROTRAN = null;
      currentRow.CDBAIRRO = null;
      currentRow.NMBAIRRO = null;
      currentRow.NMBAIRROCAN = null;
    } else {
      bairroField.readOnly = false;
      currentRow.NMBAIRROTRAN = null;
      currentRow.CDBAIRRO = null;
      currentRow.NMBAIRRO = null;
      currentRow.NMBAIRROCAN = null;
    }
  };

  this.disableSituacaoOport = function (widget) {
    if (widget.currentRow.__is_new) {
      widget.getField("SITUACAO").readOnly = true;
    } else {
      widget.getField("SITUACAO").readOnly = false;
    }
  };

  this.styleNewProspect = function (element) {
    var tr = $(element[0]);
    if (tr.hasClass("tr")) {
      tr.wrap('<a class="newLeadTooltip" title="Prospect recém criado"></a>');
    }
  };

  this.styleProspect = function (element) {
    while ($(element[0]).parent().is("a")) {
      $(element[0]).unwrap("a");
    }
  };

  this.cancelarNovoRegistro = function () {
    ScreenService.closePopup();
  };

  this.criarNovoConcorrente = function (widget) {
    var popupNovoConcorrente = templateManager.container.getWidget(
      "popupNovoConcorrente"
    );
    popupNovoConcorrente.newRow();

    popupNovoConcorrente.template = "widget/form.html";
    popupNovoConcorrente.activate();
    ScreenService.openPopup(popupNovoConcorrente);
  };

  this.prepararNovoConcorrente = function (widget) {
    CRM_Utilities.setColumnToReturnInCurrentRow(
      widget.currentRow,
      "NRCONCORRENTE"
    );
    widget.currentRow.DTULTATUBAIR = CRM_Utilities.getCurrentDate();

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.FIELDONADD = true;
    this.salvarConcorrente(widget.currentRow).then(function (response) {
      var widgetConvert = templateManager.container.getWidget("gridProspect");
      widgetConvert.currentRow.NRCONCORRENTE =
        response.dataset.columnsToReturn[0].NRCONCORRENTE;
      widgetConvert.currentRow.NMRAZSOCCONC = widget.currentRow.NMRAZSOCCONC;
      ScreenService.closePopup();
      ScreenService.closePopup();
      ScreenService.showMessage("Concorrente salvo com sucesso!");
    });
  };

  this.salvarConcorrente = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };

    return restEngine.post("/crm_concorrente/save", paramsRestEngine);
  };

  this.checkParamToAddProspect = function (widget) {
    if (templateManager.CRM_PARAMETRIZACAO.IDADDPROSPECT === "S")
      widget.getAction("ADD").isVisible = true;
  };

  this.widgetNewRow = function (widget) {
    General.widgetNewRow(widget);

    widget.currentRow.NRORG = templateManager.LOGGEDOPERATOR.NRORG;
    widget.currentRow.NRPARCRESPROSP =
      templateManager.LOGGEDOPERATOR.NRPARCNEGOCIO;
    widget.currentRow.NMPARCRESPROSP =
      templateManager.LOGGEDOPERATOR.NMOPERADOR;
    widget.currentRow.IDATIVO = "S";
    widget.currentRow.IDPRIPUBPROS = "";
    widget.currentRow.IDPRIPUBPROS = "";
    widget.currentRow.CDMODODIVULG = "";
    widget.currentRow.CDATIVCLI = "";
    widget.currentRow.CDQUALIF = "";
    widget.currentRow.CDEXPEDIENTE = "";
    widget.currentRow.CDSEGMER = "";
    widget.currentRow.IDSITUPROS = "";
    widget.currentRow.DTNASCPROS = "";
    widget.currentRow.HRINIFUNCPROSP = "";
    widget.currentRow.HRFINFUNCPROSP = "";
    widget.currentRow.IDLIGEXTPROS = "";
    widget.currentRow.NRUNOPPROS = "";
    widget.currentRow.DSCONCORREPROSP = "";
    widget.currentRow.DTENCECONTRATU = "";
    widget.currentRow.DTREVPRECOPROSP = "";
    widget.currentRow.NRSEQTPATIVCLI = "";
    widget.getField("NRINSJURPROS").readOnly = false;
    widget.getField("NMRAZSOCPROS").readOnly = false;
    widget.currentRow.IDINSCRESTAD = "ISENTO";
    widget.getField("NRINSESTPROS").value("ISENTO");
    widget.getField("NRINSESTPROS").readOnly = true;
  };

  this.checarAddProspectDireto = function (widget) {
    var paramsRestEngine = {
      requestType: "FilterData",
      filter: [
        {
          name: "NRORG",
          operator: "=",
          value: getLocalVar("CRM_NRORG"),
        },
      ],
    };
    restEngine
      .post("/crm_parametrizacao", paramsRestEngine)
      .then(function (response) {
        var paramentrizao = response.dataset.crm_parametrizacao;
        if (paramentrizao) {
          var addProsDireto = paramentrizao[0].IDADDPROSPECT;
          var addAction = widget.getAction("ADD");

          addAction.isVisible = addProsDireto == "S";

          widget.redraw();
        }
      });
  };

  this.addProspect = function (widget) {
    widget.newRow();
  };

  this.addNewTask = function (widget) {
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetNewRow(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.setUnmergeActionVisibility = function (widget) {
    var unmergeAction = widget.getAction("UNMERGE_PARC");
    unmergeAction.isVisible = false;

    if (widget.currentRow.__is_new) {
      return;
    }

    var nrparcneg = widget.currentRow.NRPARCNEGOCIO;
    var nrorg = widget.currentRow.NRORG;

    CRM_ParceiroNegocio_Controller.checkParcHasMerge(nrparcneg, nrorg).then(
      function (hasMerge) {
        // Action de desfundir será visível se o prospect tiver algum
        //parceiro fundido a ele.
        unmergeAction.isVisible = hasMerge;

        widget.redraw();
      }.bind(this)
    );
  };

  this.openSwipeUnmergeProspect = function (mainWid) {
    var nrParcNegocio = mainWid.currentRow.NRPARCNEGOCIO;
    var currentRow = mainWid.currentRow;
    var widgetUnmerge = templateManager.container.getWidget("DESFUNDIRPROSP");
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                ScreenService.closePopup();
                ScreenService.openPopup(widgetUnmerge);

                widgetUnmerge.activate();
                widgetUnmerge.newRow();

                widgetUnmerge.currentRow.NMCANDPROSPECT =
                  mainWid.currentRow.NMRAZSOCPROS;
                widgetUnmerge.currentRow.NRORG = mainWid.currentRow.NRORG;
                widgetUnmerge.currentRow.NRPARCATUAL =
                  mainWid.currentRow.NRPARCNEGOCIO;
                widgetUnmerge.currentRow.CDOPEREVOL =
                  templateManager.LOGGEDOPERATOR.CDOPERADOR;

                var filterParcDestino = widgetUnmerge
                  .getField("PARCSDESFUNDIR")
                  .dataSourceFilter.find(function (filter) {
                    return filter.name == "P_NRPARCDEST";
                  });

                filterParcDestino.value = mainWid.currentRow.NRPARCNEGOCIO;
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  //Função usada tanto na tela de lead quanto na de prospect!
  this.unmergeProspect = function (widget) {
    var mainWid = widget.getParent();

    if (widget.isValid()) {
      var parametroRestEngine = {
        requestType: "Row",
        row: widget.currentRow,
      };

      restEngine
        .post(
          "/unmergeParceiro",
          parametroRestEngine,
          undefined,
          undefined,
          undefined
        )
        .then(
          function (response) {
            CRM_Utilities.reloadGridInViewMode(mainWid).then(() => {
              this.setUnmergeActionVisibility(mainWid);
              widget.currentRow.NRPARCORIGEM = "";
              widget.currentRow.NRPARCORIGEM = "";
              this.closeWidgetFundirParc(widget);

              this.showUnmergeResultMessage(response);
            });
          }.bind(this)
        )
        .catch(function (err) {
          CRM_Utilities.showErrorMessage(err);
        });
    }
  };

  this.showUnmergeResultMessage = function (response) {
    var message = "";

    if (!response.dataset) {
      message = `Ocorreu um erro inesperado, nenhuma alteração foi feita.
                <br>Favor contatar o administrador do sistema.`;
    } else {
      if (response.dataset.DADOS.NAODESFUNDIDOS.length > 0) {
        message += "Os seguintes parceiros não foram desfundidos:<br>";
        response.dataset.DADOS.NAODESFUNDIDOS.forEach(function (parc) {
          message += `<br>-> ${parc.nome}<br>`;
        });

        if (response.dataset.DADOS.DESFUNDIDOS.length >= 1) {
          message += "<br>Os outros parceiros foram desfundidos com sucesso!";
        }
      } else {
        message += "Desfusão feita com sucesso!";
      }
    }

    ScreenService.showMessage(message);
  };

  this.criarNovoInterlocutor = function (widget) {
    var popupNovoInterlocutor = templateManager.container.getWidget(
      "popupNovoInterlocutor"
    );
    popupNovoInterlocutor.newRow();
    var filterPopup = popupNovoInterlocutor.currentRow;
    if (widget.name === "convertLeadInProspect") {
      filterPopup = templateManager.container.getWidget(
        "convertLeadInProspect"
      );
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "filterPopup") {
      filterPopup = templateManager.container.getWidget("gridProspect")
        .__filterPopup;
      popupNovoInterlocutor.currentRow.filtro = true;
    } else if (widget.name === "gridProspect") {
      filterPopup = templateManager.container.getWidget("gridProspect");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "posvendagrid") {
      filterPopup = templateManager.container.getWidget("posvendagrid");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    } else if (widget.name === "evolucao") {
      filterPopup = templateManager.container.getWidget("evolucao");
      popupNovoInterlocutor.currentRow.filtro = false;
      popupNovoInterlocutor.parentName = widget.name;
    }

    ScreenService.openPopup(popupNovoInterlocutor).then(function () {
      if (widget.name != "Agenda") {
        //Se a tela não for a de Agenda de Tarefas
        if (
          widget.parent.parent.name !== "oportunidadegrid" &&
          widget.parent.parent.name != "gridCliente"
        ) {
          //Se a tela não for a de Oportunidade ou a de Cliente
          popupNovoInterlocutor.currentRow.NMINTERLOCUTOR =
            filterPopup.NMINTERLOCUTOR;
          popupNovoInterlocutor.currentRow.DTNASCIMENTO =
            filterPopup.DTNASCIMENTO;
          popupNovoInterlocutor.currentRow.IDRECEBEPRESENTE =
            filterPopup.IDRECEBEPRESENTE;
          popupNovoInterlocutor.currentRow.NMCARGOINTERLOC =
            filterPopup.NMCARGOINTERLOC;
          popupNovoInterlocutor.currentRow.EMAILINTERLOC =
            filterPopup.EMAILINTERLOC;
          popupNovoInterlocutor.currentRow.NRTELEFONE1 =
            filterPopup.NRTELEFONE1;
          popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
        }
        if (widget.parent.parent.name == "gridCliente") {
          //Caso seja a tela de Cliente, pegar o PARCNEGOCIO do Cliente e não o logado
          popupNovoInterlocutor.currentRow.NRPARCNEGOCIO =
            widget.parent.parent.currentRow.NRPARCNEGOCIO;
        }
      } else {
        //Caso seja a tela de Agenda, pegar o PARCNEGOCIO da Tarefa
        popupNovoInterlocutor.currentRow.NRPARCNEGOCIO =
          widget.currentRow.NRPARCNEGOCIO;
      }
      popupNovoInterlocutor.currentRow.NRORG = getLocalVar("CRM_NRORG");
    });
  };

  this.setInterlocutorWidgetDefaultValues = function (widget) {
    var wid = templateManager.container.getWidget("gridProspect");

    wid.currentRow.NRPARCNEGOCIO;

    widget.currentRow.NRPARCNEGOCIO = wid.currentRow.NRPARCNEGOCIO;
  };

  this.removeInterlocutorPhoneMask = function (widget) {
    var currentRow = widget.currentRow;
    var phoneFields = ["NRTELEFONE1"];

    phoneFields.forEach(function (phone) {
      if (currentRow[phone]) {
        currentRow[phone] = currentRow[phone].replace(/[^0-9]/g, "");
      }
    });
  };

  this.salvarInterlocutor = function (currentRow) {
    var paramsRestEngine = {
      requestType: "Row",
      row: currentRow,
    };
    return restEngine.post("/crm_interlocutor/save", paramsRestEngine);
  };

  this.prepararInterlocutor = function (widget) {
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                var parent = templateManager.container.getWidget(
                  widget.parentName
                );
                //widget.currentRow.NRPARCNEGOCIO = templateManager.container.getWidget('gridCliente').currentRow.NRPARCNEGOCIO;

                CRM_Utilities.setColumnToReturnInCurrentRow(
                  widget.currentRow,
                  "NRSEQINTERLOCUTOR"
                );
                this.removeInterlocutorPhoneMask(widget);
                widget.currentRow.NRCPFINTERLOC = widget.currentRow.NRCPFINTERLOC.replace(
                  /[^0-9]/g,
                  ""
                );
                this.salvarInterlocutor(widget.currentRow).then(function (
                  response,
                  widget
                ) {
                  var currentRow = templateManager.container.getWidget(
                    "popupNovoInterlocutor"
                  );
                  if (currentRow.filtro === true) {
                    var widgetfilter = templateManager.container.getWidget(
                      "popupNovoInterlocutor"
                    ).__filterPopup;
                    var widgetprospect = templateManager.container.getWidget(
                      "gridProspect"
                    );
                    var widgetConvertfilter = templateManager.container.getWidget(
                      "evolucao"
                    );
                    widgetConvertfilter.currentRow.NMINTERLOCUTOR =
                      widget.currentRow.NMINTERLOCUTOR;

                    widgetfilter.template = "widget/form.html";
                    widgetfilter.activate();
                    widgetprospect.widgets[0].fields[7].defaultValue =
                      widget.currentRow.NMINTERLOCUTOR;
                    ScreenService.closePopup(true);
                    ScreenService.showMessage(
                      "Interlocutor criado com sucesso!"
                    );
                  } else {
                    var widgetcurrent = templateManager.container.getWidget(
                      "popupNovoInterlocutor"
                    );
                    var wid = templateManager.container.getWidget(
                      "gridProspect"
                    );

                    parent.currentRow.NRSEQINTERLOCUTOR =
                      response.dataset.columnsToReturn[0].NRSEQINTERLOCUTOR;
                    parent.currentRow.NMINTERLOCUTOR =
                      widgetcurrent.currentRow.NMINTERLOCUTOR;
                    parent.currentRow.EMAILINTERLOC =
                      widgetcurrent.currentRow.EMAILINTERLOC;

                    ScreenService.closePopup(true);

                    ScreenService.showMessage(
                      "Interlocutor criado com sucesso!"
                    ).then(function () {
                      parent.activate();
                      parent.reload();
                    });
                  }
                });
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.tabEvolucaoOnEnter = function (widget) {
    this.setEvolutionWidgetFilter(widget);
  };

  this.evolucaoRowOnEnter = function (widget) {
    this.setEditEvolButtonAction(
      widget,
      this.editEvolButtonDefaultCode,
      "EDIT"
    );
  };

  this.editEvolButtonDefaultCode = `ger45000_Prospect_Controller.editEvolution(args.owner.widget);
         ger45000_Prospect_Controller.setNextTaskVisibility(args.owner.widget, 'AGENDAR_TAREFA');`;

  this.setEditEvolButtonAction = async function (
    widget,
    codeCanEdit,
    actionName
  ) {
    if (widget.currentRow.__is_new) {
      return;
    }

    var codeCannotEdit =
      "ger45000_Prospect_Controller.showMessageCantEditEvol();";

    var editButton = widget.getAction(actionName);

    try {
      var canEdit = await this.checkIfCanEditEvol(widget);

      editButton.events[0].code = canEdit ? codeCanEdit : codeCannotEdit;
    } catch (err) {
      editButton.events[0].code = codeCanEdit;
    }
  };

  this.checkIfCanEditEvol = function (widget) {
    var params = {
      requestType: "Row",
      row: widget.currentRow,
    };

    return restEngine
      .post("/checkCanEditEvol", params)
      .then(function (response) {
        return response.dataset.DATA.CAN_EDIT;
      });
  };

  this.showMessageCantEditEvol = function () {
    var message = `Edição Bloqueada!<br>
            Não é possível editar as evoluções de outros operadores.`;

    ScreenService.showMessage(message);
  };

  this.editProspectActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetEdit(widget);
                widget.getField("NRINSJURPROS").readOnly = false;
                widget.getField("NMRAZSOCPROS").readOnly = false;
                this.classConcorrente(widget);
                CRM_ParceiroNegocio_Controller.setInscEstadualSelect(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.evolveProspectActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                this.actionEvolutionNewRow("evolucao");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.addEvolutionActionOnClick = function (widget) {
    var currentRow = widget.currentRow;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    var nrParcNegocio = widget.getParent().currentRow.NRPARCNEGOCIO;
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                widget.getField("NMRESULTEVOL").readOnly = false;
                this.evolucaoNewRow();
                this.setNextTaskVisibility(widget, "AGENDAR_TAREFA");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.showMessageCantEditParc = function () {
    var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo prospect e seus assistentes podem
             editá-lo/evoluí-lo.`;

    ScreenService.showMessage(message);
  };

  this.verifyFilter = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    var modified = false;
    widget.dataSourceFilter.forEach(function (filtro, index) {
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        !widget.fromLead &&
        !widget.fromMap
      ) {
        widget.dataSourceFilter.splice(index, 1);
        modified = true;
      }
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        (widget.fromLead || widget.fromMap)
      ) {
        widget.dataSourceFilter.splice(index, 1);
        widget.fromLead = false;
        widget.fromMap = false;
      }
    });

    if (modified && !widget.fromMap) {
      widget.reload();
    }
  };

  this.checkValidDate = function () {
    var widget = templateManager.container.getActiveWidget();
    var dataAbertura = widget.getField("DTHREVOLCONT");
    var data = dataAbertura.value().substring(0, 10);
    var dataAtual = new moment().format("DD/MM/YYYY");
    var variacao = moment(dataAtual, "DD/MM/YYYY").diff(
      moment(data, "DD/MM/YYYY"),
      "day"
    );
    var paramCRM;
    restEngine
      .post("product#/crud/crm_parametrizacao", {
        requestType: "FilterData",
        filter: [
          {
            operator: "=",
            name: "IDATIVO",
            value: "S",
          },
          {
            operator: "=",
            name: "NRORG",
            value: templateManager.LOGGEDOPERATOR.NRORG,
          },
        ],
      })
      .then(function (response) {
        paramCRM = response.dataset.crm_parametrizacao[0];

        if (variacao > paramCRM.NRDIASLANCEVOL) {
          ScreenService.showMessage(
            "Operação bloqueada!<br>Há um limite de " +
              paramCRM.NRDIASLANCEVOL +
              " dias para o lançamento retroativo de evoluções!"
          );
          widget.currentRow.DTHREVOLCONT = null;
        }
      });
  };

  this.verifyFilter = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    var modified = false;
    widget.dataSourceFilter.forEach(function (filtro, index) {
      if (
        filtro.name == "NRPARCNEGOCIO" &&
        !widget.fromLead &&
        !widget.fromMap
      ) {
        widget.dataSourceFilter.splice(index, 1);
        modified = true;
      } else if (widget.fromLead || widget.fromMap) {
        widget.dataSourceFilter.splice(index, 1);
        widget.fromMap = false;
        widget.fromLead = false;
      }
    });

    if (modified) {
      widget.reload();
    }
  };

  this.returnToMainWidget = function () {
    ScreenService.closeSwipe();
    templateManager.container.getWidget("gridProspect").activate();
  };

  this.validaFiltro = function (args) {
    var row = args.e.preference.FILTER_ROW;
    if (
      !row.NRINSJURPROS &&
      !row.NMRAZSOCPROS &&
      !row.NMFANTPROS &&
      (!row.NRPARCRESPROSP || row.NRPARCRESPROSP.length <= 0)
    ) {
      ScreenService.showMessage(
        "Preencha pelo menos um dos campos: 'Razão Social', 'Nome Fantasia', 'Inscrição' ou 'Operador Responsável'."
      ).then(function () {
        self.widgetOnEnterOnce(args.owner, ["IDATIVO"], true);
      });
    }
  };

  this.deleteFromMap = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    if (widget.fromMap) {
      delete widget.fromMap;
    }
  };

  this.removeParcOnRow = function (widget, nrparcnegocio) {
    widget.dataSource.data.forEach(function (row, index) {
      if (row.NRPARCNEGOCIO == nrparcnegocio) {
        widget.dataSource.data.splice(index, 1);
      }
    });
  };

  this.checkIfCanEditOrEvolParc = function (nrParcNegocio) {
    var restRow = {
      NRPARCNEGOCIO: nrParcNegocio,
      CRM_NRORGTRAB: getLocalVar("CRM_NRORGTRABALHO"),
    };

    var params = {
      requestType: "Row",
      row: restRow,
    };

    return restEngine
      .post("/checkIfCanEditOrEvolParc", params)
      .then((response) => {
        return response.dataset.DADOS.CAN_EDIT;
      })
      .catch(() => {
        return false;
      });
  };

  this.addNewOpportunity = function (widget) {
    var currentRow = widget.currentRow;
    var nrParcNegocio = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    this.checkIfCanEditOrEvolParc(nrParcNegocio).then((canEdit) => {
      if (widget.parent.parent.currentRow.IDATIVO === "S") {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                General.widgetNewRow(widget);
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      } else {
        ScreenService.showMessage(
          "Operação Bloqueada Pois o Prospect se encontra Inativo!<br>" + "<br>Gentileza Procurar a Equipe de Qualidade Para Ativação do Prospect"
        );
      }
    });
  };

  this.verifyFilterAssistant = function (widget) {
    //Parent widget filter
    var datFilter = widget.getParent().dataSourceFilter;
    var widgetFilter = widget.dataSourceFilter;

    var datFilterDia = datFilter.find((x) => x.name == "DTHREVOLCONT");
    var datFilterSent = datFilter.find((x) => x.name == "IDSENEVOCONT");
    var datFilterOper = datFilter.find((x) => x.name == "NRPARCRESPONSAVEL");
    var datFilterTipo = datFilter.find((x) => x.name == "CDTIPOCONT");
    var datFilterMoti = datFilter.find((x) => x.name == "CDMOTIEVOCON");
    var datFilterResu = datFilter.find((x) => x.name == "NRSEQRESULEVOL");
    var datFilterDesc = datFilter.find((x) => x.name == "TXEVOLCONT");

    //Widget filter
    var filterDia = widgetFilter.find((x) => x.name == "DTHREVOLCONT");
    var filterSent = widgetFilter.find((x) => x.name == "IDSENEVOCONT");
    var filterOper = widgetFilter.find((x) => x.name == "NRPARCRESPONSAVEL");
    var filterTipo = widgetFilter.find((x) => x.name == "CDTIPOCONT");
    var filterMoti = widgetFilter.find((x) => x.name == "CDMOTIEVOCON");
    var filterResu = widgetFilter.find((x) => x.name == "NRSEQRESULEVOL");
    var filterDesc = widgetFilter.find((x) => x.name == "TXEVOLCONT");

    //Changing widget filter
    if (Util.isEmptyOrBlank(filterDia) && !Util.isEmptyOrBlank(datFilterDia)) {
      widgetFilter.push(datFilterDia);
    } else if (!Util.isEmptyOrBlank(filterDia)) {
      filterDia.value = !Util.isEmptyOrBlank(datFilterDia.value)
        ? datFilterDia.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterSent) &&
      !Util.isEmptyOrBlank(datFilterSent)
    ) {
      widgetFilter.push(datFilterSent);
    } else if (!Util.isEmptyOrBlank(filterSent)) {
      filterSent.value = !Util.isEmptyOrBlank(datFilterSent.value)
        ? datFilterSent.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterOper) &&
      !Util.isEmptyOrBlank(datFilterOper)
    ) {
      widgetFilter.push(datFilterOper);
    } else if (!Util.isEmptyOrBlank(filterOper)) {
      filterOper.value = !Util.isEmptyOrBlank(datFilterOper.value)
        ? datFilterOper.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterTipo) &&
      !Util.isEmptyOrBlank(datFilterTipo)
    ) {
      widgetFilter.push(datFilterTipo);
    } else if (!Util.isEmptyOrBlank(filterTipo)) {
      filterTipo.value = !Util.isEmptyOrBlank(datFilterTipo.value)
        ? datFilterTipo.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterMoti) &&
      !Util.isEmptyOrBlank(datFilterMoti)
    ) {
      widgetFilter.push(datFilterMoti);
    } else if (!Util.isEmptyOrBlank(filterMoti)) {
      filterMoti.value = !Util.isEmptyOrBlank(datFilterMoti.value)
        ? datFilterMoti.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterResu) &&
      !Util.isEmptyOrBlank(datFilterResu)
    ) {
      widgetFilter.push(datFilterResu);
    } else if (!Util.isEmptyOrBlank(filterResu)) {
      filterResu.value = !Util.isEmptyOrBlank(datFilterResu.value)
        ? datFilterResu.value
        : null;
    }
    if (
      Util.isEmptyOrBlank(filterDesc) &&
      !Util.isEmptyOrBlank(datFilterDesc)
    ) {
      widgetFilter.push(datFilterDesc);
    } else if (!Util.isEmptyOrBlank(filterDesc)) {
      filterDesc.value = !Util.isEmptyOrBlank(datFilterDesc.value)
        ? datFilterDesc.value
        : null;
    }
  };

  this.returnToGrid = function () {
    var widget = templateManager.container.getActiveWidget();
    var parentWdg = widget.getParent();

    ScreenService.closeSwipe();

    parentWdg.activate();
    parentWdg.list();
  };

  this.callToConvertProspect = function (widget, parcPosicionado) {
    ScreenService.confirmMessage(
      "Deseja converter o parceiro para cliente?",
      "CONFIRMATION",
      () => {
        widget.currentRow.CDOPERADOR =
          templateManager.LOGGEDOPERATOR.CDOPERADOR;
        var currentRow = widget.currentRow;

        currentRow.CDOPERADOR = currentRow.CODOPERLOGGED;

        currentRow.NRINSESTCLIE = currentRow.NRINSESTPROS;

        this.validacaoCNPJCliente(
          widget.currentRow.NRINSJURPROS,
          widget.currentRow.NRORG
        ).then(
          function (response) {
            if (
              response.dataset &&
              response.dataset.cnpjcliente.valid === true
            ) {
              this.insertClient(currentRow).then(
                function (dataSet) {
                  if (dataSet.dataset && dataSet.dataset.CLIENTE) {
                    ScreenService.showMessage(
                      `O parceiro "${dataSet.dataset.CLIENTE[0]}" já foi convertido em Cliente anteriormente por outra organização do grupo. O Status deste parceiro foi atualizado com sucesso para Cliente!`
                    );
                    self.removeParcOnRow(widget, parcPosicionado);
                  } else {
                    ScreenService.showMessage(
                      "Prospect convertido com sucesso."
                    );
                    self.removeParcOnRow(widget, parcPosicionado);
                  }
                  widget.reload();
                  //BEGIN RD Station
                  var contactWidgets = templateManager.container.getWidget(
                    "WDGT_INTERLOCUTOR"
                  );
                  contactWidgets.dataSourceFilter.forEach(function (filter) {
                    if (filter.name === "NRPARCNEGOCIO")
                      filter.value = widget.currentRow.NRPARCNEGOCIO;
                  });
                  contactWidgets.reload().then(function () {
                    if (!Util.isEmptyOrBlank(contactWidgets.dataSource.data)) {
                      contactWidgets.dataSource.data.forEach(function (
                        contact
                      ) {
                        restEngine
                          .post("/IntegracaoRDStation/feedBackConversion", {
                            requestType: "Row",
                            row: {
                              EVENT_NAME:
                                "Cadastro convertido em cliente no CRM",
                              EMAIL: contact["EMAILINTERLOC"],
                            },
                          })
                          .then(function () {
                            restEngine.post(
                              "/IntegracaoRDStation/changeFunnel",
                              {
                                requestType: "Row",
                                row: {
                                  FUNNEL: "Client",
                                  EMAIL: contact["EMAILINTERLOC"],
                                },
                              }
                            );
                          });
                      });
                    }
                  });
                  //END RD Station
                  ScreenService.closePopup();
                  ScreenService.closeSwipe();
                }.bind(this)
              );
            } else if (
              response.dataset &&
              Array.isArray(response.dataset.cnpjcliente.valid)
            ) {
              var clientes = response.dataset.cnpjcliente.valid;
              var nomes = "";
              clientes.forEach(function (cliente) {
                nomes += "<br>" + cliente.NMRAZSOCCLIE;
              });
              ScreenService.showMessage(
                "Operação bloqueada! <br><br> Este CNPJ já está vinculado ao(s) seguinte(s) clientes(s): <br>" +
                  nomes
              );
            }
          }.bind(this)
        );
      }
    );
  };

  this.callPopupPartnerRelated = function (dados) {
    var relationshipPopup = templateManager.container.getWidget(
      "RELATIONSHIP_POPUP"
    );
    ScreenService.closePopup();

    relationshipPopup.edit();

    dados.PAI.NRAGRPARC = null;
    dados.PAI.CRM_NRORGTRAB = 20;

    var data = [dados.PAI];
    var dataaux = dados.FILHOS;

    dataaux.forEach((filho) => {
      filho.CRM_NRORGTRAB = 20;
      data.push(filho);
    });

    relationshipPopup.dataSource.data = data;

    ScreenService.openPopup(relationshipPopup);
  };

  this.popupRelationshipVoltar = function () {
    var widget = templateManager.container.getWidget("gridProspect");
    ScreenService.closePopup();
    widget.activate();
  };

  this.setParcsToConvert = function () {
    var gridWidget = templateManager.container.getWidget("gridProspect");
    var widget = templateManager.container.getWidget("RELATIONSHIP_POPUP");
    var evolWidgt = templateManager.container.getWidget("evolucao");

    var parcupdate = widget.getCheckedRows();

    gridWidget.currentRow.CDOPERADOR =
      templateManager.LOGGEDOPERATOR.CDOPERADOR;

    parcupdate.forEach((parceiro, index) => {
      var parcPosicionado = parceiro.NRPARCNEGOCIO;

      parceiro.CDOPERADOR = gridWidget.currentRow.CODOPERLOGGED;
      parceiro.NRINSJURPROS = parceiro.NRINSCRICAOPARC;
      parceiro.NMRAZSOCPROS = parceiro.NMPRINCIPALPARC;
      parceiro.NRORG = getLocalVar("CRM_NRORGTRAB");
      parceiro.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
      parceiro.DTINCLUSAO = moment(new Date()).format("DD/MM/YYYY HH:mm");
      parceiro.CURRENTOPER = templateManager.LOGGEDOPERATOR.CDOPERADOR;

      this.validacaoCNPJCliente(parceiro.NRINSJURPROS, parceiro.NRORG).then(
        (response) => {
          if (response.dataset && response.dataset.cnpjcliente.valid === true) {
            this.insertClient(parceiro).then((dataSet) => {
              if (dataSet.dataset && dataSet.dataset.CLIENTE) {
                ScreenService.notificationMessage(
                  `O parceiro "${dataSet.dataset.CLIENTE[0]}" já foi convertido em Cliente anteriormente por outra organização do grupo. O Status deste parceiro foi atualizado com sucesso para Cliente!`
                );
                self.removeParcOnRow(gridWidget, parcPosicionado);

                General.callRestEngine(
                  "product#/agrupamentoEvolSave",
                  "row",
                  evolWidgt.currentRow
                ).then((resp) => {
                  if (resp.dataset && resp.dataset.error) {
                    ScreenService.showMessage(resp.dataset.error, "ERROR");
                  } else if (resp.error) {
                    ScreenService.showMessage(resp.error, "ERROR");
                  } else {
                    ScreenService.closeSwipe();
                  }
                });
              } else {
                General.callRestEngine(
                  "product#/agrupamentoEvolSave",
                  "row",
                  evolWidgt.currentRow
                ).then((resp) => {
                  if (resp.dataset && resp.dataset.error) {
                    ScreenService.showMessage(resp.dataset.error, "ERROR");
                  } else if (resp.error) {
                    ScreenService.showMessage(resp.error, "ERROR");
                  } else {
                    ScreenService.closeSwipe();
                  }
                });
                ScreenService.showMessage(
                  "Prospect convertido com sucesso.",
                  "success"
                );
                self.removeParcOnRow(gridWidget, parcPosicionado);
              }
            });
          } else if (
            response.dataset &&
            Array.isArray(response.dataset.cnpjcliente.valid)
          ) {
            var clientes = response.dataset.cnpjcliente.valid;
            var nomes = "";
            clientes.forEach(function (cliente) {
              nomes += "<br>" + cliente.NMRAZSOCCLIE;
            });
            ScreenService.showMessage(
              "Operação bloqueada! <br><br> Este CNPJ já está vinculado ao(s) seguinte(s) clientes(s): <br>" +
                nomes
            );
          }
        }
      );
    });

    gridWidget.reload();
    ScreenService.closePopup();
    ScreenService.closeSwipe();
  };

  this.openEvolTabWithoutInterloc = function () {
    var evolWidgt = templateManager.container.getWidget("evolucaoParceiro");
    var popupRelation = templateManager.container.getWidget(
      "RELATIONSHIP_POPUP"
    );
    var gridWidgt = templateManager.container.getWidget("gridProspect");

    var currentRow = evolWidgt.currentRow;
    var nrParcNegocio = gridWidgt.currentRow.NRPARCNEGOCIO;

    ScreenService.closePopup();
    ScreenService.openPopup(evolWidgt);
    evolWidgt.activate();

    evolWidgt.CONVERTPARCS = popupRelation.getCheckedRows();

    currentRow.CRM_NRORGTRAB = getLocalVar("CRM_NRORGTRABALHO");
    currentRow.NRORG = getLocalVar("CRM_NRORGTRAB");
    currentRow.NRPARCNEGOCIO = nrParcNegocio;

    CRM_ParceiroNegocio_Controller.checkIfCanEditOrEvolParc(nrParcNegocio).then(
      (canEdit) => {
        if (canEdit) {
          General.callRestEngine("product#/verifyGroupRel", "DataSet", [
            currentRow,
          ]).then(
            function (response) {
              if (response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, "ERROR");
              }
              if (response.dataset && response.dataset.GROUPREL[0] == false) {
                evolWidgt.getField("NMRESULTEVOL").readOnly = false;
                General.widgetNewRow(evolWidgt);

                currentRow = evolWidgt.currentRow;
                var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();

                currentRow.DTHREVOLCONT = currentRow.DTHREVOLCONT
                  ? currentRow.DTHREVOLCONT
                  : moment(new Date()).format("DD/MM/YYYY HH:mm");
                currentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                currentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                currentRow.NRORG = loggedOperatorInfos.NRORG;
                currentRow.TXEVOLCONT =
                  "Convertido por meio da evolução do parceiro " +
                  gridWidgt.currentRow.NMRAZSOCPROS;

                ABEvolucaoController.setEvolDateChangePermission(evolWidgt);
                this.setOperatorNextTask(currentRow, loggedOperatorInfos);

                currentRow.DTINCLUSAO = self.momentNow();
                currentRow.NRSEQCONTATO = gridWidgt.currentRow.NRSEQCONTATO;

                currentRow.NRORG = loggedOperatorInfos.NRORG;
                this.setNextTaskVisibility(evolWidgt, "AGENDAR_TAREFA");
              } else {
                ScreenService.showMessage(
                  "Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>" +
                    response.dataset.GROUPREL[0]["NRINSCRICAOPARC"] +
                    " - " +
                    response.dataset.GROUPREL[0]["NMPRINCIPALPARC"] +
                    "!"
                );
              }
            }.bind(this)
          );
        } else {
          this.showMessageCantEditParc();
        }
      }
    );
  };

  this.cancelRelationEvolPopup = function () {
    var widget = templateManager.container.getWidget("evolucaoParceiro");
    var gridWidget = templateManager.container.getWidget("gridProspect");

    General.widgetCancelForm(widget);
    this.deleteTaskInfosInEvolutionWidget(widget);

    ScreenService.closePopup();
    gridWidget.activate();
  };
}

Configuration(function (ContextRegister) {
  ContextRegister.register(
    "ger45000_Prospect_Controller",
    ger45000_Prospect_Controller
  );
});
